// ============================================================================
//
//     IBM DOS ChipCardhCo[eBeB[
//
//
//     (C) Copyright IBM Corporation 1995, 1996
//
//     DISCLAIMER OF WARRANTIES.  The following [enclosed] code is provided
//     to you solely for the purpose of assisting you in the development of
//     your applications. The code is provided "AS IS", without warranty of
//     any kind. IBM shall not be liable for any damages arising out of your
//     use of this code, even if they have been advised of the possibility
//     of such damages.
//
//     Module Name: CHIPUTL.C
//     Date       : 3/7/95
//     Version    : 2.01
//
// ============================================================================

unsigned short OpenChipDrv( );
unsigned short CloseChipDrv( );
unsigned short Request2ChipDrv( );

// ChipCardhCo[ւ̃R}h
#define GET_CARD_INFORMATION    1               // J[h̎擾
#define READ_WRITE_SRAM         2               // SRAM/EEPROMւ̓ǂݏ
#define GET_CARD_INFORMATION2   3               // J[h̎擾 2
#define CHIPCARD_COMMAND        4               // ChipCardR}h

// ChipCardhCo[ւ̃TuR}h
#define READ_SRAM               1               // SRAM/EEPROM̓ǂݍ
#define WRITE_SRAM              2               // SRAM/EEPROMւ̏

#define POWER_ON                1               // dI
#define POWER_OFF               2               // dIt

#define CHIPCARD_TC100          1               // ChipCard TC-100
#define CHIPCARD_VW200          2               // ChipCard VW-200

// ----------------------------------------------------------------------------
//     ėpIOCtl\
// ----------------------------------------------------------------------------

// J[h̎擾
struct
{
    unsigned short Socket;                      // }Ă\Pbg̔ԍ
    unsigned char  CardType;                    // ChipCard^Cv
    unsigned char  Flag;                        // tO
    unsigned short WinHandle;                   // EBhEnh
    unsigned long  Base;                        // [EBhẼx[XAhX
    unsigned long  Size;                        // [EBhẼTCY
    unsigned long  EndOffset;                   // SRAM̈̏ĨAhX
    unsigned short Function;                    // t@NVԍ
    unsigned short Error;                       // ߂R[h
} CardInformation, *CI;

// tO
#define CARD_INFO2_EXIST        0x80            // J[h̎擾 2 

// SRAM/EEPROMւ̓ǂݏ
struct
{
    unsigned char  Command;                     // TuR}h
    unsigned long  Buffer;                      // [U[obt@ւ̃|C^[
    unsigned long  Offset;                      // J[h̃AhX
    unsigned short Size;                        // NGXg]TCY
    unsigned short ActualSize;                  // ]TCY
    unsigned short Return;                      // ߂R[h
} AccessSram, *AS;

// J[h̎擾 2
struct
{
    unsigned char Number;                       // J[hԍ
    unsigned long StartAddress1;                // JnAhX
    unsigned long Size1;                        // TCY
    unsigned char DeviceType1;                  // foCX^Cv
    unsigned short Return;                      // ߂R[h
} CardInformation2, *CI2;

// ChipCardR}h
struct
{
    unsigned char Command;
} CC_Command, *CCC;

unsigned char CSXX[] = "`t@NV";
unsigned char CS04[] = "GetConfigurationInfo";
unsigned char CS07[] = "GetFirstTuple       ";
unsigned char CS0A[] = "GetNextTuple        ";
unsigned char CS0B[] = "GetCardServicesInfo ";
unsigned char CS0C[] = "GetStatus           ";
unsigned char CS0D[] = "GetTupleData        ";
unsigned char CS10[] = "RegisterClient      ";
unsigned char CS14[] = "MapMemPage          ";
unsigned char CS1B[] = "ReleaseIO           ";
unsigned char CS1C[] = "ReleaseIRQ          ";
unsigned char CS1D[] = "ReleaseWindow       ";
unsigned char CS1E[] = "ReleaseConfiguration";
unsigned char CS1F[] = "RequestIO           ";
unsigned char CS20[] = "RequestIRQ          ";
unsigned char CS21[] = "RequestWindow       ";
unsigned char CS30[] = "RequestConfiguration";

unsigned char *CS_FUNC[0x31] =
{
    CSXX,CSXX,CSXX,CSXX,CS04,CSXX,CSXX,CS07,
    CSXX,CSXX,CS0A,CS0B,CS0C,CS0D,CSXX,CSXX,
    CS10,CSXX,CSXX,CSXX,CS14,CSXX,CSXX,CSXX,
    CSXX,CSXX,CSXX,CS1B,CS1C,CS1D,CS1E,CS1F,
    CS20,CS21,CSXX,CSXX,CSXX,CSXX,CSXX,CSXX,
    CSXX,CSXX,CSXX,CSXX,CSXX,CSXX,CSXX,CSXX,
    CS30
};

unsigned char ERRXX[] = "`̖߂R[h  ";
unsigned char ERR00[] = "I            ";
unsigned char ERR01[] = "A_v^[    ";
unsigned char ERR02[] = "          ";
unsigned char ERR03[] = "x[XAhX";
unsigned char ERR04[] = "EDC           ";
unsigned char ERR06[] = "IRQ           ";
unsigned char ERR07[] = "ItZbg    ";
unsigned char ERR08[] = "y[W        ";
unsigned char ERR09[] = "ǂݎG[      ";
unsigned char ERR0A[] = "TCY        ";
unsigned char ERR0B[] = "\Pbg      ";
unsigned char ERR0D[] = "^Cv        ";
unsigned char ERR0E[] = "Vcc           ";
unsigned char ERR0F[] = "Vpp           ";
unsigned char ERR11[] = "EBhE    ";
unsigned char ERR12[] = "݃G[      ";
unsigned char ERR14[] = "PCJ[h݂Ȃ";
unsigned char ERR15[] = "T|[gĂȂt@NV";
unsigned char ERR16[] = "T|[gĂȂ[h        ";
unsigned char ERR17[] = "x          ";
unsigned char ERR18[] = "s(rWB)      ";
unsigned char ERR19[] = "ʃG[          ";
unsigned char ERR1A[] = "CgveNg   ";
unsigned char ERR1B[] = "̒    ";
unsigned char ERR1C[] = "          ";
unsigned char ERR1D[] = "RtBO[VĂȂ";
unsigned char ERR1E[] = "łɎgpĂ";
unsigned char ERR1F[] = "ڂȂ          ";
unsigned char ERR20[] = "\[XO          ";
unsigned char ERR21[] = "nh      ";

unsigned char *CS_ERR[0x22] =
{
    ERR00,ERR01,ERR02,ERR03,ERR04,ERRXX,ERR06,ERR07,
    ERR08,ERR09,ERR0A,ERR0B,ERRXX,ERR0D,ERR0E,ERR0F,
    ERRXX,ERR11,ERR12,ERRXX,ERR14,ERR15,ERR16,ERR17,
    ERR18,ERR19,ERR1A,ERR1B,ERR1C,ERR1D,ERR1E,ERR1F,
    ERR20,ERR21
};

unsigned char AC00[] = "ChipCardhCo[t@NV";

unsigned char ERRZ0[] = "I                      ";
unsigned char ERRZ1[] = "T|[gĂȂPCJ[hł";
unsigned char ERRZ2[] = "łɃCl[uĂ܂  ";
unsigned char ERRZ3[] = "ChipCard͎gpł          ";

unsigned char *AC_ERR[4] =
{
    ERRZ0,ERRZ1,ERRZ2,ERRZ3
};

unsigned char ERRS0[] = "I                          ";
unsigned char ERRS1[] = "R}ȟ                    ";
unsigned char ERRS2[] = "CS MapMemPagẽG[             ";
unsigned char ERRS3[] = "sK؂ȃItZbgw肳܂";
unsigned char ERRS4[] = "sK؂ȃTCYw肳܂    ";
unsigned char ERRS5[] = "SRAM̏I                      ";
unsigned char ERRS6[] = "DevHlp Lock̃G[               ";  // OS/2̂
unsigned char ERRS7[] = "DevHlp PhysToVirt̃G[         ";  // OS/2̂
unsigned char ERRS8[] = "EEPROMւ݂̏̃G[        ";

unsigned char *AS_ERR[9] =
{
    ERRS0,ERRS1,ERRS2,ERRS3,ERRS4,ERRS5,ERRS6,ERRS7,ERRS8
};

unsigned char CHIP0[] = "sPCJ[h ";
unsigned char CHIP1[] = "ChipCard TC-100";
unsigned char CHIP2[] = "ChipCard VW-200";

unsigned char *CC_TYPE[3] =
{
    CHIP0,CHIP1,CHIP2
};

unsigned char DEV0[] = "      ";
unsigned char DEV1[] = "SRAM  ";
unsigned char DEV2[] = "EEPROM";

unsigned char *CC_DEV[3] =
{
    DEV0,DEV1,DEV2
};

unsigned char CI200[] = "I            ";
unsigned char CI201[] = "J[hԍ̌";

unsigned char *CI2_ERR[2] =
{
    CI200,CI201
};

#define BUFFER_SIZE     0x2000

unsigned long  Offset;
unsigned short Size;
unsigned char  Buffer[BUFFER_SIZE] = { 0 };

main( )
{
    unsigned short handle;
    unsigned short cmd = 0;
    unsigned short key = 0;
    unsigned short skt;
    unsigned short err;
    unsigned short i;
    unsigned short j;
    unsigned short k;
    unsigned char  far *p;

    // ------------------------------------------------------------------------
    //     vO/o[W̕\
    // ------------------------------------------------------------------------

    printf( "\n" );
    printf( "IBM DOS ChipCardhCo[[eBeB[ V2.01              \n"   );
    printf( "(C) Copyright IBM Corporation 1995, 1996. All rights reserved. \n\n" );

    // ------------------------------------------------------------------------
    //     ChipCardhCo[̃I[v
    // ------------------------------------------------------------------------

    handle = OpenChipDrv( );
    if ( handle == 0 )
        printf( "I[vG[: nh = %X \n\n", handle );

    // ------------------------------------------------------------------------
    //     Cj[̕\
    // ------------------------------------------------------------------------

    while( 1 )
    {
        printf( "1. J[h̎擾        \n" );
        printf( "2. SRAM/EEPROMւ̓ǂݏ \n" );
        printf( "3. J[h̎擾 2      \n" );
        printf( "4. ChipCardR}h        \n" );
        printf( "9. I                    \n" );
        printf( "R}hԍ = " );  scanf( "%d", &cmd );
        printf( "\n" );

        if ( cmd == 9 )  break;
        if ( ( cmd < 1 ) || ( cmd > 4 ) )  break;

        switch( cmd )
        {
            case GET_CARD_INFORMATION:
                printf( "**** J[h̎擾 **** \n" );
                CI = &CardInformation;
                err = Request2ChipDrv( handle, cmd, CI );
                printf( "\Pbg           = %X    \n", CI->Socket           );
                printf( "ChipCard̎     = %s    \n", CC_TYPE[CI->CardType]);  // #25
                printf( "tO             = %X    \n", CI->Flag             );  // #20
                printf( "x[XAhX     = %lXh  \n", CI->Base             );
                printf( "EBhẼTCY = %dKB  \n", (CI->Size)/1024      );
                printf( "SRAM̈̏I   = %ldKB \n", (CI->EndOffset)/1024 );  // #01

                if ( ( CI->Function & 0xFF00 ) == 0xAF00 )
                {
                    printf( "t@NV     = %s \n", CS_FUNC[CI->Function-0xAF00] );
                    printf( "߂R[h         = %s \n", CS_ERR[CI->Error]            );
                }
                else if ( ( CI->Function & 0xFF00 ) == 0xAC00 )
                {
                    printf( "t@NV     = %s \n", AC00              );
                    printf( "߂R[h         = %s \n", AC_ERR[CI->Error] );
                }
                else
                {
                    printf( "t@NV     = %X \n", CI->Function );
                    printf( "߂R[h         = %X \n", CI->Error    );
                }

                if ( err )
                    printf( "G[: G[ = %X \n", err );
                break;

            case READ_WRITE_SRAM:
                printf( "**** SRAM/EEPROMւ̓ǂݏ **** \n" );
                printf( "1. ǂݍ                       \n" );
                printf( "2.                        \n" );
                printf( "9. I                           \n" );
                printf( "R}hԍ = " );  scanf( "%d", &key );
                printf( "\n" );

                if ( key == 9 )  break;
                if ( ( key < 1 ) || ( key > 2 ) )  break;

                for ( i = 0; i < BUFFER_SIZE; ++i )  Buffer[i] = 0x20;

                AS = &AccessSram;
                AS->Command = (char) key;

                switch( key )
                {
                    case READ_SRAM:
                        p = (unsigned char far *) Buffer;
                        AS->Buffer = (unsigned long) p;
                        Offset = 0;
                        Size   = 0;
                        printf( "J[hItZbg (16i) = " );  scanf( "%lx", &Offset );
                        AS->Offset = Offset;
                        printf( "ǂݍ݃TCY           = " );  scanf( "%d", &Size );
                        AS->Size = Size;
                        break;

                    case WRITE_SRAM:
                        printf( "[U[obt@        = " );  scanf( "%s", Buffer );
                        p = (unsigned char far *) Buffer;
                        AS->Buffer = (unsigned long) p;
                        Offset = 0;
                        Size   = 0;
                        printf( "J[hItZbg (16i) = " );  scanf( "%lx", &Offset );
                        AS->Offset = Offset;
                        printf( "݃TCY           = " );  scanf( "%d", &Size );
                        AS->Size = Size;
                        break;
                }

                err = Request2ChipDrv( handle, cmd, AS );

                switch( key )
                {
                    case READ_SRAM:
                        printf( "[U[obt@        = \n" );
                        for ( i = 0; i < AS->ActualSize; i += 16 )
                        {
                            for ( j = i; ( j < AS->ActualSize ) && ( j - i < 16 ); ++j )
                            {
                                printf( "%02X ", Buffer[j] );
                            }

                            k = 16 - ( j - i );
                            if ( k != 0 )
                                for ( j = 0; j < k; ++j )  printf( "   " );

                            printf( "  " );

                            for ( j = i; ( j < AS->ActualSize ) && ( j - i < 16 ); ++j )
                            {
                                printf( "%c", Buffer[j] );
                            }

                            printf( "\n" );
                        }
                        printf( "TCY                 = %d \n", AS->ActualSize  );
                        break;

                    case WRITE_SRAM:
                        printf( "TCY                 = %d \n", AS->ActualSize  );
                        break;
                }

                printf( "߂R[h               = %s \n", AS_ERR[AS->Return] );
                break;

            case GET_CARD_INFORMATION2:
                printf( "**** J[h̎擾 2 **** \n" );
                CI = &CardInformation;
                err = Request2ChipDrv( handle, GET_CARD_INFORMATION, CI );

                if ( err )
                {
                    printf( "G[: G[ = %X \n", err );
                    break;
                }

                i = (unsigned short) ( CI->Flag & 0x07 );
                if ( i == 0 )
                {
                    printf( "J[h 2 ܂ \n" );
                    break;
                }

                CI2 = &CardInformation2;

                for ( j = 1; j <= i; ++j )
                {
                    CI2->Number = j;

                    err = Request2ChipDrv( handle, cmd, CI2 );

                    printf( "JnAhX    = %lXh \n", CI2->StartAddress1 );
                    printf( "TCY          = %dKB \n", (CI2->Size1)/1024  );
                    printf( "foCX^Cv = %s   \n", CC_DEV[CI2->DeviceType1] );
                    printf( "߂R[h      = %s   \n", CI2_ERR[CI2->Return] );
                }
                break;

            case CHIPCARD_COMMAND:
                printf( "**** ChipCardR}h **** \n" );
                printf( "1. dI                \n" );
                printf( "2. dIt                \n" );
                printf( "3. EEPROM̃veNgI \n" );
                printf( "4. EEPROM̃veNgIt \n" );
                printf( "9. I                    \n" );
                printf( "R}hԍ = " );  scanf( "%d", &key );
                printf( "\n" );

                if ( key == 9 )  break;
                if ( ( key < 1 ) || ( key > 4 ) )  break;

                CCC = &CC_Command;
                CCC->Command = (char) key;

                err = Request2ChipDrv( handle, cmd, CCC );

                break;
        }
        printf( "\n" );
    }

    // ------------------------------------------------------------------------
    //     ChipCardhCo[̃N[Y
    // ------------------------------------------------------------------------

    err = CloseChipDrv( handle );
    if ( err )
        printf( "N[YG[: G[ = %X \n", err );
}

// ----------------------------------------------------------------------------
//
//     ChipCardhCo[̃I[v
//
// ----------------------------------------------------------------------------

unsigned short OpenChipDrv( )
{
    unsigned short     handle;
    unsigned char      name[9] = "$CHIP   ";
    unsigned char near *np;

    name[8] = 0;
    np      = name;

    _asm
    {
                push    ax
                push    dx
                push    ds
                mov     ax, ss
                mov     ds, ax
                mov     dx, np
                mov     ax, 3D02h
                int     21h
                jc      err_open
                mov     handle, ax
                jmp     end_open
        err_open:
                xor     ax, ax
                mov     handle, ax
        end_open:
                pop     ds
                pop     dx
                pop     ax
    }

    return( handle );
}

// ----------------------------------------------------------------------------
//
//     ChipCardhCo[̃N[Y
//
// ----------------------------------------------------------------------------

unsigned short CloseChipDrv( unsigned short handle )
{
    unsigned short err;

    _asm
    {
                push    ax
                push    bx
                mov     ah, 3Eh
                mov     bx, handle
                int     21h
                jc      err_close
                xor     ax, ax
        err_close:
                mov     err, ax
                pop     bx
                pop     ax
    }

    return( err );
}

// ----------------------------------------------------------------------------
//
//     ChipCardhCo[ւ̃NGXg
//
// ----------------------------------------------------------------------------

unsigned short Request2ChipDrv( handle, cmd, pkt )
unsigned short handle;
unsigned short cmd;
unsigned char  *pkt;
{
    unsigned short err;

    _asm
    {
                push    ax
                push    bx
                push    cx
                push    dx
                mov     ax, 440Ch
                mov     bx, handle
                mov     ch, 0ACh
                mov     cl, cmd
                mov     dx, pkt
                int     21h
                jc      err_ioctl
                xor     ax, ax
        err_ioctl:
                mov     err, ax
                pop     dx
                pop     cx
                pop     bx
                pop     ax
    }

    return( err );
}

